<TeXmacs|1.0.7.20>

<style|<tuple|beamer|maxima|pari|mathemagix>>

<\body>
  <screens|<\shown>
    <\with|par-mode|center>
      <space|0cm|0cm|2.5fn><strong|<with|font-base-size|17|<strong|<with|color|dark
      green|GNU> <TeXmacs*>>: a scientic editing platform>>

      by Joris van der Hoeven
    </with>

    <\with|par-mode|center>
      <tabular*|<tformat|<cwith|1|1|2|2|cell-valign|c>|<table|<row|<cell|
      >|<cell|>|<cell|>>|<row|<cell|>|<cell|>|<cell|>>|<row|<cell|>|<cell|<image|texmacs-chip.ps|0.5w|0.5h||>>|<cell|>>|<row|<cell|>|<cell|>|<cell|>>|<row|<cell|>|<cell|>|<cell|>>|<row|<cell|>|<cell|ICM
      2006>|<cell|>>|<row|<cell|>|<cell|<verbatim|http://www.texmacs.org>>|<cell|>>>>>
    </with>

    \;
  </shown>|<\hidden>
    <tit|Why <TeXmacs>?>

    A scientific editing platform combines:

    <\itemize>
      <unroll|<\shown>
        <\fold-back>
          <unroll|<\shown>
            <item>Polyvalent & user-friendly editors for scientific documents
            & data.
          </shown>|<\hidden*>
            -- Mathematical formulas.
          </hidden*>|<\hidden*>
            -- Technical pictures.
          </hidden*>|<\hidden*>
            -- Typed hyperlinks and annotations.
          </hidden*>>
        </fold-back>
      </shown>|<\hidden*>
        <\fold-back>
          <unroll|<\shown>
            <item>Possibility to interface the editor with a range of extern
            software.
          </shown>|<\hidden*>
            -- Interfaces with computer algebra systems.
          </hidden*>|<\hidden*>
            -- Tools for scientific visualization.
          </hidden*>|<\hidden*>
            -- Spell checker.
          </hidden*>>
        </fold-back>
      </hidden*>|<\hidden*>
        <\fold-back>
          <unroll|<\shown>
            <item>Common transversal editing tools.
          </shown>|<\hidden*>
            -- Integrated help system.
          </hidden*>|<\hidden*>
            -- Ergonomy and typesetting quality.
          </hidden*>|<\hidden*>
            -- Undo, redo, version control.
          </hidden*>|<\hidden*>
            -- Remote tools like a wiki.
          </hidden*>|<\hidden*>
            -- Presentation mode.
          </hidden*>|<\hidden*>
            -- Import/Export
          </hidden*>>
        </fold-back>
      </hidden*>|<\hidden*>
        <\fold-back>
          <unroll|<\shown>
            <item>Customization and extensability.
          </shown>|<\hidden*>
            -- User provided style files.
          </hidden*>|<\hidden*>
            -- Scriptability via an extension language.
          </hidden*>>
        </fold-back>
      </hidden*>>
    </itemize>

    \;
  </hidden>|<\hidden>
    <tit|First steps>

    <hlink|Example paper|galois.tm> (<action|<LaTeX> export|(system "emacs
    /Users/vanderhoeven/seminar/ICM06/galois.tex &")>, <action|after
    compilation|(system "gv /Users/vanderhoeven/seminar/ICM06/galois.ps &")>,
    <action|<name|Xhtml>/<name|MathML>|(system
    "/Applications/Firefox.app/Contents/MacOS/firefox
    /Users/vanderhoeven/seminar/ICM06/galois.xhtml &")>)

    <hlink|Concrete typing|empty.tm>

    <\itemize>
      <item>Style, language.

      <item>Title, section, theorem.

      <item>Mathematics, symbols, common constructs, matrices.

      <item>Graphics.

      <item>Links.
    </itemize>
  </hidden>|<\hidden>
    <tit|Computer algebra>

    <\session|maxima|default>
      <\folded>
        A simple <name|Maxima> session
      <|folded>
        <\input|<with|color|red|(C1) >>
          diff(x^x^x,x,3);
        </input>

        <\input|<with|color|red|(C2) >>
          expand(integrate(d1,x));
        </input>

        <\input|<with|color|red|(C4) >>
          \;
        </input>
      </folded>
    </session>

    <\session|maxima|default>
      <\folded>
        Mathematical input
      <|folded>
        <\input-math|<with|color|red|(C4) >>
          integrate<left|(><frac|x<rsup|5>+x-1|x<rsup|2>-3>,x<right|)>;
        </input-math>

        <\input-math|<with|color|red|(C7) >>
          expand<left|(>diff<left|(>-<frac|log
          <left|(><frac|2*x-2*<sqrt|3>|2*x+2*<sqrt|3>><right|)>|2*<sqrt|3>>+5*log
          <left|(>x<rsup|2>-3<right|)>+<frac|x<rsup|4>+6*x<rsup|2>|4>,x<right|)><right|)>;
        </input-math>

        <\input-math|<with|color|red|(C9) >>
          \;
        </input-math>
      </folded>
    </session>

    <\session|maxima|default>
      <\folded>
        Integrated documentation
      <|folded>
        <\input|<with|color|red|(C9) >>
          plot3d([cos(x)*(3+y*cos(x/2)),sin(x)*(3+y*cos(x/2)),y*sin(x/2)],

          \ \ \ [x,-%pi,%pi],[y,-1,1],['grid,50,15])
        </input>

        <\input-math|<with|color|red|(C10) >>
          \;
        </input-math>
      </folded>
    </session>

    <\session|pari|default>
      <\folded>
        Interoperability -- Pari side
      <|folded>
        <\input-math|pari] >
          (x+y+z)<rsup|10>
        </input-math>

        <\input-math|pari] >
          \;
        </input-math>
      </folded>
    </session>

    <\session|maxima|default>
      <\folded>
        Interoperability -- Maxima side
      <|folded>
        <\input-math|<with|color|red|(C9) >>
          \;
        </input-math>
      </folded>
    </session>
  </hidden>|<\hidden>
    <tit|Computer algebra in the background>

    <unroll|<\shown>
      Computer-aided typing

      Hallo <math|1+1>

      <\equation*>
        <left|(><tabular*|<tformat|<table|<row|<cell|1>|<cell|1>|<cell|1>>|<row|<cell|a>|<cell|b>|<cell|c>>|<row|<cell|a<rsup|2>>|<cell|b<rsup|2>>|<cell|c<rsup|2>>>>>><right|)>
      </equation*>
    </shown>|<\hidden*>
      Graphics

      <plot-surface|sin(x+y<rsup|2>)|\<um\>2*\<mathpi\>|2*\<mathpi\>|\<um\>2|2>
    </hidden*>>
  </hidden>|<\hidden>
    <tit|Transversal tools>

    <\itemize>
      <item>Undo / Redo.

      <item>Remote tools.

      <item>Presentation mode.

      <item>Conversions.

      <item>Structured editing (search, variants, navigation, <abbr|etc.>).
    </itemize>
  </hidden>|<\hidden>
    <tit|Style files>

    <math|<inactive|<assign|cd|<macro|A|B|C|D|<tabular*|<tformat|<table|<row|<cell|<arg|A>>|<cell|\<longrightarrow\>>|<cell|<arg|B>>>|<row|<cell|\<longdownarrow\>>|<cell|>|<cell|\<longdownarrow\>>>|<row|<cell|<arg|C>>|<cell|\<longrightarrow\>>|<cell|<arg|D>>>>>>>>>>

    <\equation*>
      <cd|A\<oplus\>B|X|Y|C\<otimes\>D>
    </equation*>

    \;
  </hidden>|<\hidden>
    <tit|The <name|Scheme> extension language>

    <\equation*>
      a+<frac|<sqrt|x+y>|a+b>+c
    </equation*>

    <\session|scheme|default>
      <\input|scheme] >
        (select (buffer-tree) '(<with|color|magenta|:*>
        (<with|color|magenta|:match> (<with|color|dark blue|frac>
        <with|color|magenta|:1> (<with|color|dark blue|sqrt>
        <with|color|magenta|:1>)))))
      </input>

      <\input|scheme] >
        (define t

        \ \ (car (select (buffer-tree)

        \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ '(<with|color|magenta|:*>
        (<with|color|magenta|:match> (<with|color|dark blue|frac>
        <with|color|magenta|:1> (<with|color|dark blue|sqrt>
        <with|color|magenta|:1>)))))))
      </input>

      <\input|scheme] >
        (tree-set! t `(<with|color|dark blue|frac> ,(tree-ref t 1) ,(tree-ref
        t 0)))
      </input>

      <\input|scheme] >
        (tm-define (kbd-return)

        \ \ (<with|color|magenta|:inside> <with|color|dark blue|frac>)

        \ \ (with-innermost t '<with|color|dark blue|frac>

        \ \ \ \ (tree-set! t `(<with|color|dark blue|frac> ,(tree-ref t 1)
        ,(tree-ref t 0)))

        \ \ \ \ (tree-go-to t 0 :start)))
      </input>

      <\input|scheme] >
        \;
      </input>
    </session>
  </hidden>>
</body>

<\initial>
  <\collection>
    <associate|language|english>
    <associate|page-screen-top|5mm>
    <associate|prog-scripts|maxima>
    <associate|sfactor|5>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|auto-1|<tuple|1|?>>
    <associate|tfin-t-bound|<tuple|1|?>>
  </collection>
</references>